#include <avr/io.h>
#include <avr/interrupt.h>

volatile uint8_t j=0,i=0;

// w staych zapisane s stany portw we/wy odpowiadajce zawartoci poszczeglnych cianek kostki
// zmieniajc je mona uzyska rne prawdopodobiestwo wylosowania rnych stanw
const uint8_t kostka1[12] = {0b00010000,0b00010000,0b00010000,0b00010000,0b00010000,0b00010000,0b00001000,
0b00001000,0b00001000,0b00000100,0b00000010,0b0000001};

const uint8_t kostka2[12] = {0b00000001,0b00000001,0b00000001,0b00000001,0b00000001,0b00000001,0b00000010,
0b00000010,0b00000100,0b00000100,0b00001000,0b00010000};

// funkcja opniajca - do obsugi przyciskw
void wait2(uint16_t T)
{
	volatile uint16_t x,y;

	for(x=0;x<100;x++)
	{
		for(y=0;y<T;y++)
		{

		}
	}
}

// przerwanie od timera 2 - "losowanie pierwszej kostki"
ISR(TIMER2_OVF_vect)
{
	j++;
	if(j>=12)
		j=0;
}

// przerwane od timera 0 - "losowanie drugiej kostki"
ISR(TIMER0_OVF_vect)
{
		i++;
		if(i>=12)
			i=0;
}

int main(void)
{
// zmienne wykorzystane gwnie do obsugi przyciskw
uint8_t przycisk = 1,pom =0,pom2=0,czas=0,k;
// zmienna do uzyskiwania rnych oponie
uint16_t t;

// wczenie przerwa
sei();

// konfiguracja timera 2 i 0 - z rn czstotliwoci pracy (liczby losowe dla dwch kostek)
	TCCR2 |= (1<<CS21);
	TIMSK |= (1<<TOIE2);

	TCCR0 |= (1<<CS00);
	TIMSK |= (1<<TOIE0);

// konfiguracja portw wejcia i wyjscia
	DDRD = 0b00011111;
	DDRC = 0b00011111;

	PORTC = 0b00000001;
	PORTD = 0b00001000;

//gowna ptla programu
while(1)
{
// jeeli przycisk wcinity
	if(!((PIND&0b10000000)))
	{
		wait2(2);
		pom2 = 1;
	}
// jeeli przycisk poprzednio wcinity, a teraz zwolniony
	if(((PIND&0b10000000))&& pom2==1)
	{
		wait2(2);
		pom2 = 0;
		przycisk =1;
	}

// "spowalnianie i zatrzymywanie" migania po zakoczeniu losowania
	if(przycisk==1 && pom==0)
	{
		cli();
		PORTC=kostka2[i];
		PORTD=kostka1[j];
		for(k=0,t=1;k<13;k++,i++,j++)
		{
			if(i>=12)
				i=0;
			if(j>=12)
				j=0;
			PORTC = kostka2[i];
			PORTD = kostka1[j];
			wait2(t);
			t=t+15;
		}
		przycisk =0;
		pom=1;
	}

// ponowne rozpoczcie losowania
	if( przycisk==1 && pom==1)
	{
		czas=0;
		PORTC = 0b00000001;
		PORTD = 0b00001000;
		sei();
		przycisk = 0;
		pom = 0;
	}
// miganie podczas losowania
	if(przycisk ==0 && pom==0)
		{
			PORTC = (PORTC>>4)|(PORTC<<1);
			PORTD = (PORTD>>4)|(PORTD<<1);
			wait2(5);
		}
// wyczenie diod po ok 13 sekundach - oszczdzanie bbaterii
	if(przycisk ==0 && pom==1)
	{
		wait2(50);// wartos 50 mona zmieni aby uzyska inny czas po ktrym diody zgasn
		czas++;
		if(czas==150) // wartos 150 rwnie mona zmodyfikowa w tym samym celu
		{
			czas=0;
			PORTD =0;
			PORTC=0;
		}
	}
}
}
